/*******************************************************************************
 * Copyright 2008 Seapine Software, Inc. All rights reserved.
 * 
 * IMPORTANT:  This Software is supplied to you by Seapine Software, Inc. (Seapine)
 * in consideration of your agreement to the following terms, and your use, installation,
 * modification or redistribution of this Software constitutes acceptance of these terms.
 * If you do not agree with these terms, please do not use, install, modify or redistribute
 * this Software.
 * 
 * In consideration of your agreement to abide by the following terms, and subject to these
 * terms, Seapine grants you a personal, non-exclusive license, under Seapine copyrights in
 * this original Seapine software (the Software), to use, reproduce, modify and redistribute
 * the Software, with or without modifications, in source and/or binary forms; provided that
 * if you redistribute the Software in its entirety and without modifications, you must retain
 * this notice and the following text and disclaimers in all such redistributions of the Software.
 * Neither the name, trademarks, service marks or logos of Seapine, Inc. may be used to endorse
 * or promote products derived from the Software without specific prior written permission from
 * Seapine.  Except as expressly stated in this notice, no other rights or licenses, express or
 * implied, are granted by Seapine herein, including but not limited to any patent rights that
 * may be infringed by your derivative works or by other works in which the Software may be
 * incorporated.
 * 
 * The Software is provided by Seapine on an "AS IS" basis.  SEAPINE MAKES NO WARRANTIES,
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE IMPLIED WARRANTIES OF NON-INFRINGEMENT,
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, REGARDING THE SOFTWARE OR ITS USE AND
 * OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS. 
 * 
 * IN NO EVENT SHALL SEAPINE BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE,
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE SOFTWARE, HOWEVER CAUSED AND WHETHER
 * UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN
 * IF SEAPINE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/


using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net.Mail;

namespace SendFileForReview
{
    class Program
    {
        static void Main(string[] args)
        {
         //Let's get the comments from the event to see if we need to send an e-mail.
            string eventComments = System.Environment.GetEnvironmentVariable("SSCM_COMMENT");
            if (eventComments.Contains("<e-mail:"))//if we find the token
            {
                //let's parse the token from the comments
                Int32 startPos = eventComments.IndexOf("<");
                Int32 endPos = eventComments.IndexOf(">");
                startPos = startPos + 1;
                Int32 lenghtOfToken = endPos - startPos;
                //now that we have our starting position and lenght of the token, let's get it!
                string token = eventComments.Substring(startPos, lenghtOfToken);
                

                //Next step is to copy the file to a temporary location to rename it and then attach it to the e-mail
                //First, we have to define some variables
                
                //The name of the file that we will be attaching to the e-mail
                string scmFileName = System.Environment.GetEnvironmentVariable("SSCM_FILE");
                //Path where we will place the file for processing - must exist!
                string scmFilePath = "C:\\emailtrigger";
                //The temporary file that is copied from the user's working directory to the server for server
                //processing (diff's merging, etc...) This is the file we want!!!
                string scmFile = System.Environment.GetEnvironmentVariable("SSCM_LOCALFILE");
                //Let's copy and rename the file so we can send it
                FileInfo fileToSend = new FileInfo(scmFile);
                fileToSend.CopyTo(scmFilePath + "\\"+ scmFileName, true);

                
                //Get variables for e-mail subject and body
                string scmEventUser = System.Environment.GetEnvironmentVariable("SSCM_USER");
                string scmRepo = System.Environment.GetEnvironmentVariable("SSCM_REPOSITORY");
                string scmBranch = System.Environment.GetEnvironmentVariable("SSCM_BRANCH");
                
                //Now let's build the e-mail object                                         
                MailMessage theMessage = new MailMessage();
                //Let's figure out who we are sending this e-mail to
                Int32 charPos = token.IndexOf(":");
                //Anything after the colon (":") will be an e-mail address
                string emailAddress = token.Substring(charPos + 1);
                //Write what we have to a text file for troubleshooting purposes
                Logger.write(emailAddress);
                //We need to check if there are more than one e-mail address
                //Each address must be separated by a semi-colon, so let's see if we have one
                if (emailAddress.Contains(";"))
                {
                    //get the position of the first semi colon
                    charPos = emailAddress.IndexOf(";");
                    while (charPos > 0)
                    {
                        //anything before the first semi colon is the first e-mail address
                        string emailTo = emailAddress.Substring(0,charPos);
                        //add the e-mail address to the e-mail object
                        theMessage.To.Add(emailTo);
                        //strip this e-mail address from the string
                        emailAddress = emailAddress.Substring(charPos +1);
                        //get the position of the next semi colon to see if we have more than one e-mail address left
                        charPos = emailAddress.IndexOf(";");
                        //write it to the file to make sure we are stripping addresses correctly
                        Logger.write(emailAddress);
                    }
                    
                }
                //If only one e-mail address, add it to the e-mail object
                //If there were multiple addresses, add the last one to the e-mail object
                theMessage.To.Add(emailAddress);
                //Set the address that will show as the "From" - Your SMTP Host may not send the e-mail if this a bogus e-mail
                //address of if does not match with the authentication you pass
                theMessage.From = new System.Net.Mail.MailAddress("FromAddress@isp.com");
                //Set the subject of the e-mail
                theMessage.Subject = scmEventUser + " requests that you review " + scmFileName + "(attached)";
                //Build the body of the e-mail
                string emailBody = scmEventUser + " would like for you to review the file " + scmFileName + " before it is checked in.\n";
                emailBody += "The File was checked out from " + scmBranch + " branch and " + scmRepo + " repository.\n";
                //Set the body of the e-mail                
                theMessage.Body = emailBody;
                //Get the file to attach
                System.Net.Mail.Attachment fileToAttach = new Attachment(scmFilePath + "\\" + scmFileName);
                //Set the attachment
                theMessage.Attachments.Add(fileToAttach);
                //Initiate an SMTP client object to send the e-mail, must pass the FQDN host name and port number (25 is default)
                System.Net.Mail.SmtpClient smtp = new System.Net.Mail.SmtpClient("SMTP Host", 25);
                //Set the SMTP host authentication credentials - if your SMTP does not require authentication, comment out the line below
                smtp.Credentials = new System.Net.NetworkCredential("<username>", "<password>");
                //Now that we have our message, let's send it!
                try
                {
                    smtp.Send(theMessage);
                }
                catch (Exception f)
                {
                    //If there is an error sending the message, let me know about it!
                    Logger.log("Sending e-mail error occurred: " + f.Message);
                }

                //Last two items are to reset the custom field used as a flag and to set the file state to "In Review".

                //First, we declare the Surround SCM Server authentication and communication paramaters - change this to match your set up.
                string scmUser = "Administrator";
                string scmUserPassword = "password";
                string scmServerAddress = "127.0.0.1";
                string scmServerPort = "4900";

                //Now we reset the custom field that prevents the check in back to nothing
                string commandParams = "setcustomfield " + "\"" + scmFileName + "\"" + " 1004 " + "unchecked" + " -b" + "\"" + scmBranch + "\"" + " -p" + "\"" + scmRepo + "\"" + " -y" + "\"" + scmUser + ":" + scmUserPassword + "\"" + " -z" + "\"" + scmServerAddress + ":" + scmServerPort + "\"";
                //Write the command to a text file so if it fails we can troubleshoot it
                Logger.write(commandParams);

                string sscmresult = sscmexe.sscmCMD(commandParams);
                //Write any error to the log file
                Logger.log(sscmresult);

                //Last but not least, we set the file state to "In review"
                commandParams = "setstate " + "\"" + scmFileName + "\"" + " 17 " + " -b" + "\"" + scmBranch + "\"" + " -p" + "\"" + scmRepo + "\"" + " -y" + "\"" + scmUser + ":" + scmUserPassword + "\"" + " -z" + "\"" + scmServerAddress + ":" + scmServerPort + "\"";
                //Write the command to a text file so if it fails we can troubleshoot it
                Logger.write(commandParams);

                sscmresult = sscmexe.sscmCMD(commandParams);
                //Write any error to the log file
                Logger.log(sscmresult);

            }
	 

        }
    }
}
